> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://virtuous.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://virtuous.ferndocs.com/_mcp/server.

# Update a Volunteer Attendance

PUT https://api.virtuoussoftware.com/api/VolunteerOpportunity/{volunteerOpportunityId}/Attendance/{volunteerAttendanceId}
Content-Type: application/json

Reference: https://virtuous.ferndocs.com/reference/crm-plus/volunteering/update-a-volunteer-attendance

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.virtuoussoftware.com` (https://api.virtuoussoftware.com, default)
- `{{baseUrl}}api` ({{baseUrl}}api)

## Request

### Path parameters

- `volunteerOpportunityId` (string, required)
- `volunteerAttendanceId` (string, required)

### Body (application/json)

This endpoint expects an object.

- `timeZone` (string, optional)
- `hours` (string, optional)
- `startDateTimeUtc` (string, optional)
- `endDateTimeUtc` (string, optional)

## Response

### 200

OK

- `id` (string, optional)
- `volunteerAttendanceUrl` (string, optional)
- `volunteerId` (string, optional)
- `volunteerUrl` (string, optional)
- `volunteerOpportunityId` (string, optional)
- `volunteerOpportunityUrl` (string, optional)
- `hours` (string, optional)
- `startDateTimeUtc` (string, optional)
- `startDateTime` (string, optional)
- `endDateTimeUtc` (string, optional)
- `endDateTime` (string, optional)
- `timeZone` (string, optional)
- `createDateTimeUtc` (string, optional)
- `createdByUser` (string, optional)
- `modifiedDateTimeUtc` (string, optional)
- `modifiedByUser` (string, optional)

## Errors

### 400 Bad Request Error

BadRequest

- `any`

### 404 Not Found Error

NotFound

- `any`

## Examples

**Request**

```json
{
  "timeZone": "<string>",
  "hours": "<double>",
  "startDateTimeUtc": "<dateTime>",
  "endDateTimeUtc": "<dateTime>"
}
```

**Response**

```json
{
  "id": "<integer>",
  "volunteerAttendanceUrl": "<string>",
  "volunteerId": "<integer>",
  "volunteerUrl": "<string>",
  "volunteerOpportunityId": "<integer>",
  "volunteerOpportunityUrl": "<string>",
  "hours": "<double>",
  "startDateTimeUtc": "<dateTime>",
  "startDateTime": "<dateTime>",
  "endDateTimeUtc": "<dateTime>",
  "endDateTime": "<dateTime>",
  "timeZone": "<string>",
  "createDateTimeUtc": "<dateTime>",
  "createdByUser": "<string>",
  "modifiedDateTimeUtc": "<dateTime>",
  "modifiedByUser": "<string>"
}
```

**SDK Code**

```python Volunteering_updateAVolunteerAttendance_example
import requests

url = "https://api.virtuoussoftware.com/api/VolunteerOpportunity/volunteerOpportunityId/Attendance/volunteerAttendanceId"

payload = {
    "timeZone": "<string>",
    "hours": "<double>",
    "startDateTimeUtc": "<dateTime>",
    "endDateTimeUtc": "<dateTime>"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript Volunteering_updateAVolunteerAttendance_example
const url = 'https://api.virtuoussoftware.com/api/VolunteerOpportunity/volunteerOpportunityId/Attendance/volunteerAttendanceId';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"timeZone":"<string>","hours":"<double>","startDateTimeUtc":"<dateTime>","endDateTimeUtc":"<dateTime>"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Volunteering_updateAVolunteerAttendance_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.virtuoussoftware.com/api/VolunteerOpportunity/volunteerOpportunityId/Attendance/volunteerAttendanceId"

	payload := strings.NewReader("{\n  \"timeZone\": \"<string>\",\n  \"hours\": \"<double>\",\n  \"startDateTimeUtc\": \"<dateTime>\",\n  \"endDateTimeUtc\": \"<dateTime>\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Volunteering_updateAVolunteerAttendance_example
require 'uri'
require 'net/http'

url = URI("https://api.virtuoussoftware.com/api/VolunteerOpportunity/volunteerOpportunityId/Attendance/volunteerAttendanceId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"timeZone\": \"<string>\",\n  \"hours\": \"<double>\",\n  \"startDateTimeUtc\": \"<dateTime>\",\n  \"endDateTimeUtc\": \"<dateTime>\"\n}"

response = http.request(request)
puts response.read_body
```

```java Volunteering_updateAVolunteerAttendance_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.virtuoussoftware.com/api/VolunteerOpportunity/volunteerOpportunityId/Attendance/volunteerAttendanceId")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"timeZone\": \"<string>\",\n  \"hours\": \"<double>\",\n  \"startDateTimeUtc\": \"<dateTime>\",\n  \"endDateTimeUtc\": \"<dateTime>\"\n}")
  .asString();
```

```php Volunteering_updateAVolunteerAttendance_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.virtuoussoftware.com/api/VolunteerOpportunity/volunteerOpportunityId/Attendance/volunteerAttendanceId', [
  'body' => '{
  "timeZone": "<string>",
  "hours": "<double>",
  "startDateTimeUtc": "<dateTime>",
  "endDateTimeUtc": "<dateTime>"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Volunteering_updateAVolunteerAttendance_example
using RestSharp;

var client = new RestClient("https://api.virtuoussoftware.com/api/VolunteerOpportunity/volunteerOpportunityId/Attendance/volunteerAttendanceId");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"timeZone\": \"<string>\",\n  \"hours\": \"<double>\",\n  \"startDateTimeUtc\": \"<dateTime>\",\n  \"endDateTimeUtc\": \"<dateTime>\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Volunteering_updateAVolunteerAttendance_example
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "timeZone": "<string>",
  "hours": "<double>",
  "startDateTimeUtc": "<dateTime>",
  "endDateTimeUtc": "<dateTime>"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.virtuoussoftware.com/api/VolunteerOpportunity/volunteerOpportunityId/Attendance/volunteerAttendanceId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```